#include <iostream>

#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif

#include <IL/ilut.h>

#include "square.h"

using namespace std;

Square *theSquare;

void display( void )
{
	glClear( GL_COLOR_BUFFER_BIT );
	theSquare->Render();
	glutSwapBuffers();
}

void initgl(void)
{
	glClearColor( .3, .3, .3, 1 );
}

void reshape( int w, int h )
{
	static int first = 1;
	if (first)
	{
		first = 0;
		initgl();
	}
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	
	glOrtho( -w/2, w/2-1, -h/2, h/2-1, -1, 1 );
	glViewport( 0, 0, w, h );
	
	theSquare->WindowWidth( w, h );
	glutPostRedisplay();
}

void keyboard( unsigned char key, int x, int y )
{
	if (key == 27) // ESC
	{
		exit(0);
	}
	if (key == 't' || key == 'T')
	{
		theSquare->ToggleTexturing();
	}
	
	glutPostRedisplay();
}

static bool doing_it = false;

void mouse( int button, int state, int x, int y )
{
	if (button == GLUT_LEFT && state == GLUT_DOWN)
	{
		theSquare->Click( x, y );
		doing_it = true;
	}
	else doing_it = false;
	glutPostRedisplay();
}

void motion( int x, int y )
{
	if (doing_it)
	{
		theSquare->Drag( x, y );
		glutPostRedisplay();
	}
}

int main (int argc, char *argv[]) {
	
	glutInit( &argc, argv );
	glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE );
	glutInitWindowSize( 500, 500 );
	
	glutCreateWindow( "Intro Graphics Assignment 0" );
	
	glutDisplayFunc( display );
	glutReshapeFunc( reshape );
	glutKeyboardFunc( keyboard );
	glutMouseFunc( mouse );
	glutMotionFunc( motion );

	ilInit();
	iluInit();
	ilutRenderer(ILUT_OPENGL);
	ilutInit();

	theSquare = new Square( 100 );
	
	glutMainLoop();
}
